Foreman - Bug #21926

Compute-resource image creation allows duplicate name
12/11/2017 11:42 AM - Marek Hulan

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: VM management
Target version: 1.18.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1517092 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5081
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1517092

Description of problem: Satellite allows to create compute-resource image with same name.

hammer> compute-resource image list --compute-resource 'rhev_compute'

| | I |

ID | NAME | OPERATING SYSTEM | USERNAME | UUID

-~ | | |

20 | latest | RedHat 7.3 | root | 09b7babe-4514-4585-9dcc-fbfef071256d
21 | latest | RedHat 7.3 | root | 79ef62d4-1d04-44e0-9e3d-2223529b0253

This can be problematic, If there are multiple images with same name. Commands to list info shows Error: found more than one

image

hammer> compute-resource image info --compute-resource 'rhev_compute' --name latest --operatingsystem-id 6
Error: found more than one image

Version-Release humber of selected component (if applicable): Satellite 6.3 snap 25

How reproducible: always

Steps to Reproduce:

1. compute-resource image create --compute-resource rhev_compute --name 'latest' --username 'root' --password 'password'

--architecture 'x86_64" --operatingsystem 'RedHat 7.3' --uuid '<uuid>"'

2. compute-resource image create --compute-resource rhev_compute --name 'latest' --username 'root' --password 'password'
--architecture 'x86_64" --operatingsystem 'RedHat 7.3 --uuid '<uuid_changed>'

Actual results:

Allows to create compute-resource image with duplicate names.

Expected results:

It should validate and no duplicate/same name images creation should allow.

Additional info: This can be reproduced on WebUI as well.

Related issues:
Blocks Foreman - Refactor #21639: unique constraints should be enforced in th... Resolved

Associated revisions

Revision a186f43b - 01/08/2018 07:46 AM - Tomer Brisker
https://bugzilla.redhat.com/show_bug.cgi?id=1517092

Fixes #21926 - Ensure uniqueness on image names and uuids (#5081)

Image names should be unique per CR and OS. UUID uniqueness is already
enforced by ActiveRecord but not in the DB, which could cause conflicts

in multi-proccess environments. Also cleaned up a bit of the image tests

and made them all use FactoryBot instead of fixtures.

History

#1 - 12/13/2017 04:40 PM - Tomer Brisker

- Blocks Refactor #21639: unique constraints should be enforced in the DB as well added

#2 - 12/13/2017 04:43 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/5081 added

#3 - 12/13/2017 04:51 PM - Tomer Brisker

- Subject changed from Compute-resource image creation allows duplicate name
to Compute-resource image creation allows duplicate name

- Assignee changed from Chris Roberts to Tomer Brisker

#4 - 01/08/2018 07:47 AM - Marek Hulan

- translation missing: en.field_release set to 330

#5 - 01/08/2018 08:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a186f43bc5aa61bddc3667763afee036f90d9adO0.
